//UmrandungErzeugen_501d.js
// 14.02.11 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Erzeugt eine Umrandung aus Kopien eines Objekts

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// "Keine" Farbe und "Passkreuze" je nach Version
var noColor = "[Ohne]";
var rgColor = "[Passermarken]";
if (app.version[0] == 4) {
	noColor = "[Keine]";
	rgColor = "[Passkreuze]";
}
dontChange = "Nicht ndern";

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.", "Achtung");
	exit();
}

// eine Referenz zum Dokument
var curDoc = app.documents[0];

// die Version speichern (wenn die Objekte temporr benannt werden, 
// muss man je nach Version 'name' oder 'label' verwenden)
var versNum = app.version[0];

// prfen, ob ein Objekt ausgewhlt ist
var curSel = app.selection;
var nFrames = curSel.length;
if (nFrames == 0) {
	alert ("Es ist nichts ausgewhlt.", "Stop");
	exit();
}
else if (nFrames > 1) {
	alert ("Nur *ein* Objekt auswhlen.", "Stop");
	exit();
}

// "Schwarz" bestimmen
if ((app.locale)*1 == 1279477613) { // deutsches InDesign
	var blackCol = "Schwarz";
}
else if ((app.locale)*1 == 1279477362) { // franzsisches InDesign
	var blackCol = "Noir";
}
else if ((app.locale)*1 == 1279477102 || (app.locale)*1 == 1279477097) { // englisches InDesign
	var blackCol = "Black";
}
else {
	var blackCol = "Schwarz";
}

// den Drehwinkel des Objekts speichern
var curAngle = curSel[0].rotationAngle;

// den Handler aufrufen, welcher die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var frmW = prefVal[0]*1;
	var frmH = prefVal[1]*1;
	var dVal = prefVal[2]*1;
	var rVal = prefVal[3]*1;
	var elWd = prefVal[4];
	if (elWd == "true") {
		ck01 = true;
	}
	else {
		ck01 = false;
	}
	var grFr = prefVal[5];
	if (grFr == "true") {
		ck02 = true;
	}
	else {
		ck02 = false;
	}
	var bName = prefVal[6];
	if (bName == "Black") { bName = "[" + blackCol + "]"; }
	else if (bName == "Paper") { bName = "[Papier]"; }
	else if (bName == "Registration") { bName = rgColor; }
	else if (bName == "None") { bName = noColor; }
	var bgrT  = prefVal[7]*1;
	var sName = prefVal[8];
	if (sName == "Black") { sName = "[" + blackCol + "]"; }
	else if (sName == "Paper") { sName = "[Papier]"; }
	else if (sName == "Registration") { sName = rgColor; }
	else if (sName == "None") { sName = noColor; }
	var strT = prefVal[9]*1;
	var strW = prefVal[10]*1;
	var alig = prefVal[11];
	var rb01 = 1;
	var rb02 = 0;
	var rb03 = 0;
	if (alig == "1") {
		rb01 = 0;
		rb02 = 1;
	}
	else if (alig == "2") {
		rb01 = 0;
		rb03 = 1;
	}
	var rDec = prefVal[12]*1;
	var rb04 = rb05 = rb06 = rb07 = rb08 = rb09 = rb10 = rb11 = 0;
	if      (rDec == 0) { rb04 = 1; }
	else if (rDec == 1) { rb05 = 1; }
	else if (rDec == 2) { rb06 = 1; }
	else if (rDec == 3) { rb07 = 1; }
	else if (rDec == 4) { rb08 = 1; }
	else if (rDec == 5) { rb09 = 1; }
	else if (rDec == 6) { rb10 = 1; }
	else if (rDec == 7) { rb11 = 1; }
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	var frmW =   45;
	var frmH =   45;
	var dVal =    0;
	var rVal =    0;
	var ck01 = false;
	var ck02 = true;
	var bgrT =  100;
	var strT =  100;
	var strW =  0.5;
	var rb01 =    0;
	var rb02 =    1;
	var rb03 =    0;
	var rb04 =    1;
	var rb05 =    0;
	var rb06 =    0;
	var rb07 =    0;
	var rb08 =    0;
	var rb09 =    0;
	var rb10 =    0;
	var rb11 =    0;
	var bName = dontChange;
	var sName = dontChange;
}

// die Handler aufrufen, welche die Listen der Farben vorbereiten
var bgrColor = getBgrColorList(bName);
var bgrCol   = bgrColor[0];
var bInd     = bgrColor[1];
var strColor = getStrColorList(sName);
var strCol   = strColor[0];
var sInd     = strColor[1];

// die Masseinheiten speichern
// wenn nicht 2053991795 (= Millimeter), dann auf Millimeter umstellen
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}

// den Bezugspunkt in der Mitte auswhlen
var trp = app.layoutWindows[0].transformReferencePoint;
if (trp != 1095656308) {
	app.layoutWindows[0].transformReferencePoint = 1095656308;
}

// den Nullpunkt auf Null/Null setzen
var zP = curDoc.zeroPoint; 
if (zP != [0,0]) { 
	curDoc.zeroPoint = [0,0]; 
}

// den Handler aufrufen, welcher den Dialog zeigt und auswertet
var anArray = displayDialog(frmW, frmH, dVal, rVal, ck01, ck02, bInd, bgrT, sInd, strT, strW, 
rb01, rb02, rb03, rb04, rb05, rb06, rb07, rb08, rb09, rb10, rb11);
frmW   = anArray[0];
frmH   = anArray[1];
dVal   = anArray[2];
rVal   = anArray[3];
elWd   = anArray[4];
grFr   = anArray[5];
bColor = anArray[6];
bgrT   = anArray[7];
sColor = anArray[8];
strT   = anArray[9];
strW   = anArray[10];
strA   = anArray[11];
rDec   = anArray[12];
noRota = false;
if (rDec      == 0) { // alle Spitzen nach innen
	topLineRot  =    0 + curAngle;
	rgtLineRot  =  -90 + curAngle;
	botLineRot  = -180 + curAngle;
	lftLineRot  = -270 + curAngle;
}
else if (rDec == 1) { // alle Spitzen nach aussen
	topLineRot  = -180 + curAngle;
	rgtLineRot  = -270 + curAngle;
	botLineRot  =    0 + curAngle;
	lftLineRot  =  -90 + curAngle;
}
else if (rDec == 2) { // Kreislauf links herum
	topLineRot  =  -90 + curAngle;
	rgtLineRot  = -180 + curAngle;
	botLineRot  = -270 + curAngle;
	lftLineRot  =    0 + curAngle;
}
else if (rDec == 3) { // Kreislauf rechts herum
	topLineRot  = -270 + curAngle;
	rgtLineRot  =    0 + curAngle;
	botLineRot  =  -90 + curAngle;
	lftLineRot  = -180 + curAngle;
}
else if (rDec == 4) { // alle Spitzen nach unten
	topLineRot  =    0 + curAngle;
	rgtLineRot  =    0 + curAngle;
	botLineRot  =    0 + curAngle;
	lftLineRot  =    0 + curAngle;
	noRota = true;
}
else if (rDec == 5) { // alle Spitzen nach links
	topLineRot  =  -90 + curAngle;
	rgtLineRot  =  -90 + curAngle;
	botLineRot  =  -90 + curAngle;
	lftLineRot  =  -90 + curAngle;
}
else if (rDec == 6) {  // alle Spitzen nach oben
	topLineRot  = -180 + curAngle;
	rgtLineRot  = -180 + curAngle;
	botLineRot  = -180 + curAngle;
	lftLineRot  = -180 + curAngle;
	noRota = true;
}
else if (rDec == 7) { // alle Spitzen nach rechts
	topLineRot  = -270 + curAngle;
	rgtLineRot  = -270 + curAngle;
	botLineRot  = -270 + curAngle;
	lftLineRot  = -270 + curAngle;
}

// die Gruppierung vorbereiten
groupObjects = new Array ();

// das ausgewhlte Objekt
curFrame = curSel[0];

// die Funktion zum Zuweisen von Objektfarbe und -tonwert aufrufen
if (bColor != dontChange) {
	setBgrColr(bColor, bgrT);
}

// die Funktion zum Zuweisen von Konturstrke, -farbe, -tonwert und -Ausrichtung aufrufen
if (sColor != dontChange) {
	setStroke(sColor, strW, strT, strA);
}

// die Funktion aufrufen, welche die Abmessungen speichert
defVal = getBounds();
y1 = defVal[0];
x1 = defVal[1];
y2 = defVal[2];
x2 = defVal[3];

// die Werte runden
var objH = (Math.floor(((y2-y1)*1000)+0.5))/1000;
var objW = (Math.floor(((x2-x1)*1000)+0.5))/1000;

// Variablen, deren Wert (noch) nicht im Dialog einstellbar ist
compVal = 1;
offVal  = (objW*1.0738032)+dVal;
moveVal = (objW/3.2)*1;

if (rVal == 0) { // wenn der Radiuswert Null ist
	// die Funktion aufrufen, welche das Objekt im Uhrzeigersinn dupliziert
	if (objH == objW) { // ein quadratisches Objekt
		duplObjSquare();
	}
	else { // das Objekt ist hher als breit oder breiter als hoch
		if (elWd) {
			duplObjLongElast();
		}
		else {
			duplObjLong();
		}
	}
}
else {
	if ((rVal/(objW+dVal)) > 2.35) {
		if ((frmW-(rVal*2)) > (objW*2)+(dVal*3)) {
			// Aufruf der Funktion, welche die Ecken abrundet
			roundedCorners();
		}
		else {
			// Aufruf der Funktion, welche die Objekte im Kreis anordnet
			perfectCircle();
		}
	}
	else {
		// wenn der Radius-Wert zu klein ist, werden die Ecken 
		// "abgerundet", indem nur *ein* Ecken-Objekt gedreht wird 
		
		// Aufruf der Funktion, welche das Objekt dupliziert
		roundedOne();
		
		// Aufruf der Funktion, welche die Ecken-Objekte dreht
		rotateObj();
		
		// Aufruf der Funktion, welche die Ecken-Objekte verschiebt
		moveObj();
	}
}

// den Handler zum Gruppieren aufrufen
var curGroup = groupObj(groupObjects);

// die Bounds der fertigen Gruppe
if (!strVisible) {
	gB = curGroup.geometricBounds;
	// Hhe und Breite zuweisen, um minime Rundungsdifferenzen zu korrigieren
	curGroup.geometricBounds = [gB[0], gB[1], gB[0] + frmH, gB[1] + frmW];
}

// die Gruppe auflsen (falls nicht gewnscht)
if (!grFr) {
	curGroup.ungroup();
}

// die Auswahl aufheben
app.selection = null;

// die Funktion zum Zurcksetzen der Vorgaben aufrufen
restorePrefs();

////////////////////////////// Funktion "getPrefs"  Anfang  ////////////////////////////////////////////
// die Funktion , welche die Informationen vorbereitet
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/Umrandung_01.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}
////////////////////////////// Funktion "getPrefs"  Ende  /////////////////////////////////////////////

////////////////////////////// Funktion "getBgrColorList"  Anfang  ////////////////////////////////////
// die Funktion, welche die Liste der Hintergrund-Farben vorbereitet
function getBgrColorList(bName) {
	// eine Variable als Referenz zu den Farbfeldern des aktiven Dokuments definieren
	var allSwatches = curDoc.swatches;
	
	// prfen, ob die Vorgabefarbe existiert
	if (bName != dontChange && bName != "[" + blackCol + "]" && bName != "[Papier]" && bName != noColor && bName != rgColor) {
		try {
			curDoc.swatches.itemByName(bName).name;
		}
		catch (e) {
			bName = "[" + blackCol + "]";
		}
	}
	
	// die Liste der Farben zusammenstellen;
	// "None", "Paper", "Black" und "Registration" umbenennen;
	// die Position der Vorgabefarbe feststellen
	var bgrColorList = new Array(dontChange);
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = "[Papier]";
		}
		else if (cName == "Black") {
			cName = "[" + blackCol + "]";
		}
		else if (cName == "Registration") {
			cName = rgColor;
		}
		if (bName == cName) {
			bIndex = i;
		}
		if (cName != "Registration") {
			bgrColorList.push(cName);
		}
	}
	if (bName == dontChange) {
		bIndex = 0;
	}
	else {
		bIndex++;
	}
	return [bgrColorList, bIndex];
}
////////////////////////////// Funktion "getBgrColorList"  Ende  //////////////////////////////////////

////////////////////////////// Funktion "getStrColorList"  Anfang  ////////////////////////////////////
// die Funktion , welche die Liste der Kontur-Farben vorbereitet
function getStrColorList(sName) {
	// eine Variable als Referenz zu den Farbfeldern des aktiven Dokuments definieren
	var allSwatches = curDoc.swatches;
	
	// prfen, ob die Vorgabefarbe existiert
	if (sName != dontChange && sName != "[" + blackCol + "]" && sName != "[Papier]" && sName != noColor && sName != rgColor) {
		try {
			curDoc.swatches.itemByName(sName).name;
		}
		catch (e) {
			sName = "[" + blackCol + "]";
		}
	}
	
	// die Liste der Farben zusammenstellen;
	// "None", "Paper", "Black" und "Registration" umbenennen;
	// die Position der Vorgabefarbe feststellen
	var strColorList = new Array(dontChange);
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = "[Papier]";
		}
		else if (cName == "Black") {
			cName = "[" + blackCol + "]";
		}
		else if (cName == "Registration") {
			cName = rgColor;
		}
		if (sName == cName) {
			sIndex = i;
		}
		if (cName != "Registration") {
			strColorList.push(cName);
		}
	}
	if (sName == dontChange) {
		sIndex = 0;
	}
	else {
		sIndex++;
	}
	return [strColorList, sIndex];
}
////////////////////////////// Funktion "getStrColorList"  Ende  //////////////////////////////////////

////////////////////////////// Funktion "displayDialog"  Anfang  //////////////////////////////////////
// Funktion zum Anzeigen und Auswerten des Dialoges
function displayDialog(frmW, frmH, dVal, rVal, ck01, ck02, bInd, bgrT, sInd, strT, strW, rb01, rb02, rb03, rb04, rb05, rb06, rb07, rb08, rb09, rb10, rb11) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 95;
	var fieldWidth = 40;
	var aDialog = app.dialogs.add({name:"UmrandungErzeugen"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Rahmenbreite", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var widthField = realEditboxes.add({editValue:frmW, minimumValue:10, maximumValue:9999, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Rahmenhhe", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var heightField = realEditboxes.add({editValue:frmH, minimumValue:10, maximumValue:9999, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Abstand", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var distField = realEditboxes.add({editValue:dVal, minimumValue:-10, maximumValue:9999, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Radius", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var radiField = realEditboxes.add({editValue:rVal, minimumValue:0, maximumValue:9999, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		var elasCheckbox = checkboxControls.add({staticLabel:"Elemente elastisch anpassen", checkedState:ck01});
		var grpeCheckbox = checkboxControls.add({staticLabel:"Fertige Umrandung gruppieren", checkedState:ck02});
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Hintergrund", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var bgrColor = dropdowns.add({stringList:bgrCol, selectedIndex:bInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Tonwert", minWidth:labelWidth-10});
					var bgrTint = realEditboxes.add({editValue:bgrT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Kontur", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var strColor = dropdowns.add({stringList:strCol, selectedIndex:sInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Tonwert", minWidth:labelWidth-10});
					var strTint = realEditboxes.add({editValue:strT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Konturstrke", minWidth:labelWidth-10});
					var strWeight = realEditboxes.add({editValue:strW, minimumValue:0, maximumValue:5, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"pt", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Ausrichtung", minWidth:labelWidth-10});
					with(aligButtons = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"mittig", checkedState:rb01});
						radiobuttonControls.add({staticLabel:"innen",  checkedState:rb02});
						radiobuttonControls.add({staticLabel:"aussen", checkedState:rb03});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Elemente drehen", minWidth:20});
					staticTexts.add({staticLabel:" ", minWidth:20});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"", minWidth:28});
					with(rotationButtons = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"Alle Spitzen nach innen",  checkedState:rb04});
						radiobuttonControls.add({staticLabel:"Alle Spitzen nach aussen", checkedState:rb05});
						radiobuttonControls.add({staticLabel:"Kreislauf links herum",    checkedState:rb06});
						radiobuttonControls.add({staticLabel:"Kreislauf rechts herum",   checkedState:rb07});
						radiobuttonControls.add({staticLabel:"Alle Spitzen nach unten",  checkedState:rb08});
						radiobuttonControls.add({staticLabel:"Alle Spitzen nach links",  checkedState:rb09});
						radiobuttonControls.add({staticLabel:"Alle Spitzen nach oben",   checkedState:rb10});
						radiobuttonControls.add({staticLabel:"Alle Spitzen nach rechts", checkedState:rb11});
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		var frmW = widthField.editValue;
		var frmH = heightField.editValue;
		var dVal = distField.editValue;
		var rVal = radiField.editValue;
		var ck01 = elasCheckbox.checkedState;
		var ck02 = grpeCheckbox.checkedState;
		bgrIndex = bgrColor.selectedIndex;
		if (bgrIndex != 0) {
			bColor = curDoc.swatches[bgrIndex-1].name;
		}
		else {
			bColor = dontChange;
		}
		if (bColor == "[" + blackCol + "]") { bColor = "Black"; }
		else if (bColor == "[Papier]") { bColor = "Paper"; }
		else if (bColor == rgColor) { bColor = "Registration"; }
		else if (bColor == noColor) { bColor = "None"; }
		bgrT = bgrTint.editValue;
		strIndex = strColor.selectedIndex;
		if (strIndex != 0) {
			sColor = curDoc.swatches[strIndex-1].name;
		}
		else {
			sColor = dontChange;
		}
		if (sColor == "[" + blackCol + "]") { sColor = "Black"; }
		else if (sColor == "[Papier]") { sColor = "Paper"; }
		else if (sColor == rgColor) { sColor = "Registration"; }
		else if (sColor == noColor) { sColor = "None"; }
		strT = strTint.editValue;
		strW = strWeight.editValue;
		var aligDec = aligButtons.selectedButton;
		if (aligDec == 0) {
			strA = 1936998723; // mittig
		}
		else if (aligDec == 1) {
			strA = 1936998729; // innen
		}
		else if (aligDec == 2) {
			strA = 1936998735; // aussen
		}
		var rDec = rotationButtons.selectedButton;
		aDialog.destroy();
		var prefsList = new Array (frmW, frmH, dVal, rVal, ck01, ck02, bColor, bgrT, sColor, strT, strW, aligDec, rDec);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return [frmW, frmH, dVal, rVal, ck01, ck02, bColor, bgrT, sColor, strT, strW, strA, rDec];
	}
	else{
		aDialog.destroy();
		restorePrefs();
		exit();
	}
}
////////////////////////////// Funktion "displayDialog"  Ende  ////////////////////////////////////////

////////////////////////////// Funktion "writeResult"  Anfang  ////////////////////////////////////////
// das Ergebnis in eine Datei schreiben
function writeResult(curPrefs) {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/Umrandung_01.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}
////////////////////////////// Funktion "writeResult"  Ende  //////////////////////////////////////////

////////////////////////////// Funktion "setbgrColr"  Anfang  /////////////////////////////////////////
// Funktion zum Zuweisen von Hintergrundfarbe und -tonwert
function setBgrColr(bColor, bgrT) {
	try {
		if (bColor != 0) {
			if (bColor == "Papier") {  // "Papier" in "Paper" umbenennen
				bColor = "Paper";
			}
			else if (bColor == " + blackCol + ") {  // "Schwarz" in "Black" umbenennen
				bColor = "Black";
			}
			// einen Tonwert von 100 in das korrektere -1 ndern
			if (bgrT == 100) {
				bgrT = -1;
			}
			// Farbe und Tonwert zuweisen
			curFrame.properties = {fillColor:bColor, fillTint:bgrT};
		}
	}
	catch (e) {
		restorePrefs();
		exit();
	}
}
////////////////////////////// Funktion "setBgrColr"  Ende  ///////////////////////////////////////////

////////////////////////////// Funktion "setStroke"  Anfang  //////////////////////////////////////////
// Funktion zum Zuweisen von Konturstrke, -farbe und -tonwert
function setStroke(sColor, strW, strT, strA) {
	try {
		if (sColor == "Papier") {  // "Papier" in "Paper" umbenennen
			sColor = "Paper";
		}
		else if (sColor == " + blackCol + ") {  // "Schwarz" in "Black" umbenennen
			sColor = "Black";
		}
		// einen Tonwert von 100 in das korrektere -1 ndern
		if (strT == 100) {
			strT = -1;
		}
		// Farbe, Tonwert und Ausrichtung zuweisen
		curFrame.properties = {strokeColor:sColor, strokeWeight:strW, strokeTint:strT, strokeAlignment:strA};
	}
	catch (e) {
		restorePrefs();
		exit();
	}
}
////////////////////////////// Funktion "setStroke"  Ende  ////////////////////////////////////////////

////////////////////////////// Funktion "getBounds"  Anfang  //////////////////////////////////////////
// diese Funktion holt die Werte der Grsse des Objekts
function getBounds() {
	// die Kontur prfen
	strVisible = false;
	var curStrC = curFrame.strokeColor.name;
	if (curStrC != "None") {
		var curStrA = curFrame.strokeAlignment;
		if (curStrA != 1936998729) { // Ausrichtung ist nicht "innen"
			strVisible = true;
		}
	}
	else {
		if (curFrame.constructor.name == "GraphicLine") {
			strVisible = true;
		}
	}
	if (strVisible) {
		// die "sichtbaren Bounds" des Objekts speichern ...
		var vB = curFrame.visibleBounds;
		var y0 = (Math.floor((vB[0]*1000)+0.5))/1000;
		var x0 = (Math.floor((vB[1]*1000)+0.5))/1000;
		var y1 = (Math.floor((vB[0]*1000)+0.5))/1000;
		var x1 = (Math.floor((vB[1]*1000)+0.5))/1000;
		var y2 = (Math.floor((vB[2]*1000)+0.5))/1000;
		var x2 = (Math.floor((vB[3]*1000)+0.5))/1000;
		// den gewnschten Drehwinkel fr Linie oben zuweisen
		curFrame.rotationAngle = topLineRot;
		// die "sichtbaren Bounds" des Objekts erneut speichern ...
		var vB = curFrame.geometricBounds;
		var y1 = (Math.floor((vB[0]*1000)+0.5))/1000;
		var x1 = (Math.floor((vB[1]*1000)+0.5))/1000;
		var y2 = (Math.floor((vB[2]*1000)+0.5))/1000;
		var x2 = (Math.floor((vB[3]*1000)+0.5))/1000;
	}
	else {
		// die "geometrischen Bounds" des Objekts speichern ...
		var gB = curFrame.geometricBounds;
		var y0 = (Math.floor((gB[0]*1000)+0.5))/1000;
		var x0 = (Math.floor((gB[1]*1000)+0.5))/1000;
		var y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
		var x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
		var y2 = (Math.floor((gB[2]*1000)+0.5))/1000;
		var x2 = (Math.floor((gB[3]*1000)+0.5))/1000;
		// den gewnschten Drehwinkel fr Linie oben zuweisen
		curFrame.rotationAngle = topLineRot;
		// die "geometrischen Bounds" des Objekts erneut speichern ...
		var gB = curFrame.geometricBounds;
		var y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
		var x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
		var y2 = (Math.floor((gB[2]*1000)+0.5))/1000;
		var x2 = (Math.floor((gB[3]*1000)+0.5))/1000;
	}
	
	// das Objekt verschieben, falls die Rotation dessen Position gendert hat
	if (y0 != y1 || x0 != x1) {
		curFrame.move(undefined, [(x0-x1), (y0-y1)]);
	}
	return [y1, x1, y2, x2];
}
////////////////////////////// Funktion "getBounds"  Ende  ////////////////////////////////////////////

////////////////////////////// Funktion "duplObjSquare"  Anfang  //////////////////////////////////////
// Funktion zum Duplizieren eines quadratischen Objekts im Uhrzeigersinn
function duplObjSquare() {
	// das Grundobjekt in die Gruppieren-Liste aufnehmen
	groupObjects.push(curFrame);
	// die Objektbreite
	var oneWidth  = (Math.floor(((x2-x1)*1000)+0.5))/1000;
	// die Anzahl horizontaler Elemente ...
	var nItemsHor = (Math.floor((frmW+dVal)/(oneWidth+dVal)));
	// der eigentliche Abstand und der Versatz
	var realXSpace = (Math.floor(((frmW-(nItemsHor*oneWidth))/(nItemsHor-1)*1000)+0.5))/1000;
	var xOffset = oneWidth+realXSpace;
	// die Objekthhe
	var oneHeight  = (Math.floor(((y2-y1)*1000)+0.5))/1000;
	// die Anzahl vertikaler Elemente ...
	var nItemsVer = Math.floor((frmH-((oneHeight*2)+dVal))/(oneHeight+dVal));
	var realYSpace = (Math.floor(((frmH-(nItemsVer*oneHeight)-(oneHeight*2))/(nItemsVer+1)*1000)+0.5))/1000;
	var yOffset = oneHeight+realYSpace;
	
	// wenn elastisch, dann Breite und Hhe anpassen
	if (elWd) {
		oneWidth  = (frmW - ((nItemsHor-1)*dVal))/ nItemsHor;
		oneHeight = (frmH - ((nItemsVer+1)*dVal))/(nItemsVer+2);
		if (strVisible) {
			// die "sichtbaren Bounds" des Objekts speichern ...
			vB = curFrame.visibleBounds;
			y1 = (Math.floor((vB[0]*1000)+0.5))/1000;
			x1 = (Math.floor((vB[1]*1000)+0.5))/1000;
			curFrame.visibleBounds = [y1, x1, y1+oneHeight, x1+oneWidth];
		}
		else {
			// die "geometrischen Bounds" des Objekts speichern ...
			gB = curFrame.geometricBounds;
			y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
			x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
			curFrame.geometricBounds = [y1, x1, y1+oneHeight, x1+oneWidth];
		}
		var xOffset = oneWidth+dVal;
		var yOffset = oneHeight+dVal;
	}
	
	// ---------- die vier Rnder ----------
	// oberer Rand (von links nach rechts)
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// rechter Rand (von oben nach unten)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = rgtLineRot;
	curFrame.move(undefined, [0, yOffset]);
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, yOffset]);
		groupObjects.push(curFrame);
	}
	// unterer Rand (von rechts nach links)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = botLineRot;
	curFrame.move(undefined, [0, yOffset]);
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [-xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// linker Rand (von unten nach oben)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = lftLineRot;
	curFrame.move(undefined, [0, -yOffset]);
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, -yOffset]);
		groupObjects.push(curFrame);
	}
}
////////////////////////////// Funktion "duplObjSquare"  Ende  ////////////////////////////////////////

////////////////////////////// Funktion "duplObjLong"  Anfang  ////////////////////////////////////////
// Funktion zum Duplizieren eines lnglichen Objekts im Uhrzeigersinn
function duplObjLong() {
	// das Grundobjekt in die Gruppieren-Liste aufnehmen
	groupObjects.push(curFrame);
	// die Objektbreite
	var oneWidth  = (Math.floor(((x2-x1)*1000)+0.5))/1000;
	// die Anzahl horizontaler Elemente ...
	var nItemsHor = (Math.floor((frmW+dVal)/(oneWidth+dVal)));
	var realXSpace = (Math.floor(((frmW-(nItemsHor*oneWidth))/(nItemsHor-1)*1000)+0.5))/1000;
	var xOffset = oneWidth+realXSpace;
	// unterscheiden zwischen "nichtgedrehten" und "gedrehten" Objekten 
	if (noRota || (rDec == 5) || (rDec == 7)) {
		// die Objekthhe
		var oneHeight = (Math.floor(((y2-y1)*1000)+0.5))/1000;
		// die Anzahl vertikaler Elemente, der Abstand und der Versatz
		var nItemsVer = Math.floor((frmH-((oneHeight*2)+dVal))/(oneHeight+dVal));
		var realYSpace = (Math.floor(((frmH-(nItemsVer*oneHeight)-(oneHeight*2))/(nItemsVer+1)*1000)+0.5))/1000;
		var yOffset = oneHeight+realYSpace;
	}
	else {
		// die Objektbreite wird zur Hhe, neuer Wert fr Breite
		var oneHeight = oneWidth;
		var oneWidth  = (Math.floor(((y2-y1)*1000)+0.5))/1000;
		// die Anzahl vertikaler Elemente, der Abstand und der Versatz
		var nItemsVer = Math.floor((frmH-((oneWidth*2)+dVal))/(oneHeight+dVal));
		var realYSpace = (Math.floor(((frmH-(nItemsVer*oneHeight)-(oneWidth*2))/(nItemsVer+1)*1000)+0.5))/1000;
		var yOffset = oneHeight+realYSpace;
	}
	
	// ---------- die vier Rnder ----------
	// oberer Rand (von links nach rechts)
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// rechter Rand (von oben nach unten)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = rgtLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, yOffset]);
	}
	else {
		curFrame.move(undefined, [(oneHeight/2)-(oneWidth/2), (oneHeight/2)+(oneWidth/2)+realYSpace]);
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, yOffset]);
		groupObjects.push(curFrame);
	}
	// unterer Rand (von rechts nach links)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = botLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, yOffset]);
	}
	else {
		curFrame.move(undefined, [-((oneHeight/2)-(oneWidth/2)), (oneHeight/2)+(oneWidth/2)+realYSpace]);
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [-xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// linker Rand (von unten nach oben)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = lftLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, -yOffset]);
	}
	else {
		curFrame.move(undefined, [-((oneHeight/2)-(oneWidth/2)), -((oneHeight/2)+(oneWidth/2)+realYSpace)]);
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, -yOffset]);
		groupObjects.push(curFrame);
	}
}
////////////////////////////// Funktion "duplObjLong"  Ende  //////////////////////////////////////////

////////////////////////////// Funktion "duplObjLongELAST"  Anfang  ///////////////////////////////////
// Funktion zum Duplizieren eines lnglichen Objekts im Uhrzeigersinn
function duplObjLongElast() {
	// das Grundobjekt in die Gruppieren-Liste aufnehmen
	groupObjects.push(curFrame);
	// die Objektbreite
	var oneWidthX  = (Math.floor(((x2-x1)*1000)+0.5))/1000;
	// die Objekthhe
	var oneHeightX = (Math.floor(((y2-y1)*1000)+0.5))/1000;
	// die Anzahl horizontaler Elemente ...
	var nItemsHor = (Math.floor((frmW+dVal)/(oneWidthX+dVal)));
	var elaWidthX = (frmW-((nItemsHor-1)*dVal))/nItemsHor;
	x2 = x1+elaWidthX;
	curFrame.geometricBounds = [y1, x1, y2, x2];
	var xOffset = elaWidthX+dVal;
	// unterscheiden zwischen "nichtgedrehten" und "gedrehten" Objekten 
	if (noRota || (rDec == 5) || (rDec == 7)) {
		// die Anzahl vertikaler Elemente, der Abstand und der Versatz
		var nItemsVer = Math.floor((frmH-((oneHeightX*2)+dVal))/(oneHeightX+dVal));
		var realYSpace = (Math.floor(((frmH-(nItemsVer*oneHeightX)-(oneHeightX*2))/(nItemsVer+1)*1000)+0.5))/1000;
		var yOffset = oneHeightX+realYSpace;
	}
	else {
		// die alte Objektbreite wird zur Hhe, neuer Wert fr Breite
		var oneHeightY = oneWidthX;
		var oneWidthY  = (Math.floor(((y2-y1)*1000)+0.5))/1000;
		// die Anzahl vertikaler Elemente, der Abstand und der Versatz
		var nItemsVer = (Math.floor((frmH-((oneHeightX*2)+dVal))/(oneHeightY+dVal)))+1;
		var elaHeightY = (frmH-((oneHeightX*2)+dVal)-((nItemsVer)*dVal))/nItemsVer;
		var realYSpace = dVal;
		var yOffset = elaHeightY+dVal;
	}
	
	// ---------- die vier Rnder ----------
	// oberer Rand (von links nach rechts)
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// rechter Rand (von oben nach unten)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = rgtLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, yOffset]);
	}
	else {
		curFrame.move(undefined, [(elaWidthX/2)-(oneHeightX/2), (oneHeightX/2)+(elaWidthX/2)+dVal]);
		gB = curFrame.geometricBounds;
		y1 = gB[0];
		x1 = gB[1];
		y2 = y1 + elaHeightY;
		x2 = gB[3];
		curFrame.geometricBounds = [y1, x1, y2, x2];
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, yOffset]);
		groupObjects.push(curFrame);
	}
	// unterer Rand (von rechts nach links)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = botLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, yOffset]);
	}
	else {
		curFrame.move(undefined, [-((elaHeightY/2)-(oneWidthY/2)), (elaHeightY/2)+(oneWidthY/2)+realYSpace]);
		gB = curFrame.geometricBounds;
		y1 = gB[0];
		x1 = gB[3] - elaWidthX;
		y2 = gB[2];
		x2 = gB[3];
		curFrame.geometricBounds = [y1, x1, y2, x2];
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [-xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// linker Rand (von unten nach oben)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = lftLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, -yOffset]);
	}
	else {
		curFrame.move(undefined, [-((elaWidthX/2)-(oneHeightX/2)), -((oneHeightX/2)+(elaWidthX/2)+dVal)]);
		gB = curFrame.geometricBounds;
		y1 = gB[2] - elaHeightY;
		x1 = gB[1];
		y2 = gB[2];
		x2 = gB[3];
		curFrame.geometricBounds = [y1, x1, y2, x2];
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, -yOffset]);
		groupObjects.push(curFrame);
	}
}
////////////////////////////// Funktion "duplObjLongElast"  Ende  /////////////////////////////////////

////////////////////////////// Funktion "roundedCorners"  Anfang  /////////////////////////////////////
// Funktion zum Abrunden der Ecken
function roundedCorners() {
	// das Grundobjekt in die Gruppieren-Liste aufnehmen
	groupObjects.push(curFrame);
	if (strVisible) {
		// die "sichtbaren Bounds" des Objekts speichern ...
		vB = curFrame.visibleBounds;
		y1 = (Math.floor((vB[0]*1000)+0.5))/1000;
		x1 = (Math.floor((vB[1]*1000)+0.5))/1000;
		y2 = (Math.floor((vB[2]*1000)+0.5))/1000;
		x2 = (Math.floor((vB[3]*1000)+0.5))/1000;
	}
	else {
		// die "geometrischen Bounds" des Objekts speichern ...
		gB = curFrame.geometricBounds;
		y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
		x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
		y2 = (Math.floor((gB[2]*1000)+0.5))/1000;
		x2 = (Math.floor((gB[3]*1000)+0.5))/1000;
	}
	// Breite und Hhe
	oneWidth  = x2-x1;
	oneHeight = y2-y1;
	
	// der ussere Radius
	var oRad = rVal;
	// der mittlere Radius
	var mRad = oRad-(objW/2)
	var pi   = 3.14159;
	// die Lnge des Viertelkreisbogens (mittlerer Radius = Position der Objekt-Mittelpunkte) 
	var sectM = (2*pi*mRad)/4;
	// die Lnge des Viertelkreisbogens (Original-Radius multipliziert mit einem Kompensationswert);
	// je nach Element wird der zu verteilende Wert beeinflusst, damit die Abstnde auf den 
	// Kreisbogen und den Geraden *optisch* mglichst hnlich sind
	var sectR = ((2*pi*oRad)/4)*compVal;
	
	// Anzahl der Elemente auf dem Bogen
	var nItems = (Math.floor(sectM/(objW+dVal)))-1;
	// die Anzahl der Elemente der geraden Strecken
	var nHorItems = (Math.floor((frmW-(oRad*2))/(oneWidth+dVal)))+1;
	var nVerItems = (Math.floor((frmH-(oRad*2))/(oneHeight+dVal)))+1;
	
	// wenn elastisch, dann Breite und Hhe anpassen
	if (elWd) {
		oneWidth  = ((frmW-(oRad*2)) + oneWidth - ((nHorItems-1)*dVal))/(nHorItems);
		oneHeight = ((frmH-(oRad*2)) + oneHeight - ((nVerItems-1)*dVal))/(nVerItems);
		curFrame.visibleBounds = [y1, x1, y1+oneHeight, x1+oneWidth];
	}
	
	// die gegebenen Zwischenrume addieren ...
	var distSector = sectR-((nItems+1)*oneWidth);
	var distStrght = (frmW-(oRad*2))-((nHorItems-1)*oneWidth);
	// ... den idealen Zwischenraum errechnen ...
	var distIdeal  = ((distSector*4)+(distStrght*4))/((nItems*4)+(nHorItems*4));
	// ... und schliesslich den neuen Radius berechnen
	oRad = (frmW-((nHorItems-1)*oneWidth)-((nHorItems-1)*distIdeal))/2;
	
	// wenn elastisch, dann Breite und Hhe *erneut* anpassen
	if (elWd) {
		oneWidth  = ((frmW-(oRad*2)) + oneWidth - ((nHorItems-1)*dVal))/(nHorItems);
		oneHeight = ((frmH-(oRad*2)) + oneHeight - ((nVerItems-1)*dVal))/(nVerItems);
		curFrame.visibleBounds = [y1, x1, y1+oneHeight, x1+oneWidth];
	}
	
	// ---------- die definitiven Werte vorbereiten ----------
	// der mittlere Radius
	var mRad = oRad-(oneWidth/2);
	
	// die Anzahl aller Elemente
	var nAllItems = (nItems*4)+(nHorItems*2)+(nVerItems*2);
	
	// der reelle Versatz
	if (elWd) {
		var realXOff = oneWidth+dVal;
		var realYOff = oneHeight+dVal;
	}
	else {
		var realXOff = (frmW-(oRad*2))/(nHorItems-1);
		var realYOff = (frmH-(oRad*2))/(nVerItems-1);
	}
	
	// der Schrittwert
	var oneAngle = 90/(nItems+1);
	
	// die Winkel der Basiselemente
	var angListBE = new Array ();
	var curAngle = 90;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBE.push(newAngle);
		curAngle = newAngle;
	}
	
	// die Winkel der Eckenelemente
	// Ecke links oben
	var angListTL = new Array ();
	var curAngle = lftLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListTL.push(newAngle);
		curAngle = newAngle;
	}
	// Ecke rechts oben
	var angListTR = new Array ();
	var curAngle = topLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListTR.push(newAngle);
		curAngle = newAngle;
	}
	// Ecke rechts unten
	var angListBR = new Array ();
	var curAngle = rgtLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBR.push(newAngle);
		curAngle = newAngle;
	}
	// Ecke links unten
	var angListBL = new Array ();
	var curAngle = botLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBL.push(newAngle);
		curAngle = newAngle;
	}
	
	// die Winkel der geraden Elemente
	// Linie oben
	var angListT = new Array ();
	for (var i=0; i<nHorItems; i++) {
		angListT.push(topLineRot);
	}
	// Linie rechts
	var angListR = new Array ();
	for (var i=0; i<nVerItems; i++) {
		angListR.push(rgtLineRot);
	}
	// Linie unten
	var angListB = new Array ();
	for (var i=0; i<nHorItems; i++) {
		angListB.push(botLineRot);
	}
	// Linie links
	var angListL = new Array ();
	for (var i=0; i<nVerItems; i++) {
		angListL.push(lftLineRot);
	}
	
	// die Positionsparameter aller Eckenelemente
	// Ecke links oben
	var posListTL = new Array ();
	for (var i=nItems-1; i>-1; i--) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (oRad-(mRad*xPos))-(oneWidth/2);
		var yPos = Math.sin(curVal);
		y = (oRad-(mRad*yPos))-(oneHeight/2);
		posListTL.push([x,y]);
	}
	// Ecke rechts oben
	var posListTR = new Array ();
	for (var i=0; i<nItems; i++) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (frmW-(oRad-(mRad*xPos)))-(oneWidth/2);
		var yPos = Math.sin(curVal);
		y = (oRad-(mRad*yPos))-(oneHeight/2);
		posListTR.push([x,y]);
	}
	// Ecke rechts unten
	var posListBR = new Array ();
	for (var i=nItems-1; i>-1; i--) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (frmW-(oRad-(mRad*xPos)))-(oneWidth/2);
		var yPos = Math.sin(curVal);
		y = (frmH-(oRad-(mRad*yPos)))-(oneHeight/2);
		posListBR.push([x,y]);
	}
	// Ecke links unten
	var posListBL = new Array ();
	for (var i=0; i<nItems; i++) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (oRad-(mRad*xPos))-(oneWidth/2);
		var yPos = Math.sin(curVal);
		y = (frmH-(oRad-(mRad*yPos)))-(oneHeight/2);
		posListBL.push([x,y]);
	}
	
	// die Positionsparameter aller geraden Elemente
	// Linie oben
	var posListT = new Array ();
	var curVal = oRad-(oneWidth/2);
	for (var i=0; i<nHorItems; i++) {
		posListT.push([curVal, 0]);
		curVal += realXOff;
	}
	// Linie rechts
	var posListR = new Array ();
	var curVal = oRad-(oneWidth/2);
	for (var i=0; i<nVerItems; i++) {
		posListR.push([frmW-oneWidth, curVal]);
		curVal += realYOff;
	}
	// Linie unten
	var posListB = new Array ();
	var curVal = (frmW-oRad)-(oneWidth/2);
	for (var i=0; i<nHorItems; i++) {
		posListB.push([curVal, frmH-oneHeight]);
		curVal -= realXOff;
	}
	// Linie links
	var posListL = new Array ();
	var curVal = (frmH-oRad)-(oneHeight/2);
	for (var i=0; i<nVerItems; i++) {
		posListL.push([0, curVal]);
		curVal -= realYOff;
	}
	// die Liste aller Positionsparameter
	var allPosList = posListTL.concat(posListT, posListTR, posListR, posListBR, posListB, posListBL, posListL);
	
	// die Liste aller Winkel
	var allAngList = angListTL.concat(angListT, angListTR, angListR, angListBR, angListB, angListBL, angListL);
	
	// wenn die gewnschten Winkel alle gleich sind, die Winkelliste anpassen
	if ((topLineRot == rgtLineRot) && (topLineRot == botLineRot) && (topLineRot == lftLineRot)) {
		var nVals = allAngList.length;
		for (var i=0; i<nVals; i++) {
			allAngList[i] = topLineRot;
		}
	}
	
	// das Objekt duplizieren, entsprechend der gewnschten Anzahl
	if (versNum == 7) {
		curFrame.name = "0_";
		for (var i=0; i<nAllItems-1; i++) {
			curFrame = curFrame.duplicate(undefined, [0, 0]);
			curFrame.name = "" + (i+1) + "_";
			groupObjects.push(curFrame);
		}
	}
	else {
		curFrame.label = "0_";
		for (var i=0; i<nAllItems-1; i++) {
			curFrame = curFrame.duplicate(undefined, [0, 0]);
			curFrame.label = "" + (i+1) + "_";
			groupObjects.push(curFrame);
		}
	}
	
	// die Objekte der Reihe nach auf ihre Position verschieben
	// und den Drehwinkelwert zuweisen
	for (var i=0; i<nAllItems; i++) {
		curDoc.pageItems.itemByName("" + i + "_").move(allPosList[i], undefined);
		curDoc.pageItems.itemByName("" + i + "_").rotationAngle = (allAngList[i]);
		curDoc.pageItems.itemByName("" + i + "_").move(undefined, [x1, y1]);
		if (versNum == 7) {
			curDoc.pageItems.itemByName("" + i + "_").name = "";
		}
		else {
			curDoc.pageItems.itemByName("" + i + "_").label = "";
		}
	}
}
////////////////////////////// Funktion "roundedCorners"  Ende  ///////////////////////////////////////

////////////////////////////// Funktion "perfectCircle"  Anfang  //////////////////////////////////////
// Funktion zum Erzeugen eines perfekten Kreises
function perfectCircle() {
	// der ussere Radius
	oRad = frmW/2;
	
	// der mittlere Radius und die Lnge des Viertelkreises
	var mRad = oRad-(objW/2)
	var pi   = 3.14159;
	var sect = (2*pi*oRad)/4;
	
	// Anzahl der Elemente auf dem Bogen
	var nItems = (Math.floor(sect/(objW+dVal)))-1;
	if (nItems == Infinity || nItems < 1) {
		alert ("Problem:\n\nDas Objekt kann nicht dupliziert werden.", " ");
		restorePrefs();
		exit();
	}
	// die Anzahl aller Elemente
	var nHorItems = 1;
	var nVerItems = 1;
	var nAllItems = (nItems*4)+2+2;
	
	// der Schrittwert
	var oneAngle = 90/(nItems+1);
	
	// die Winkel der Basiselemente
	var angListBE = new Array ();
	var curAngle = 90;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBE.push(newAngle);
		curAngle = newAngle;
	}
	
	// die Winkel der Eckenelemente
	// Ecke links oben
	var angListTL = new Array ();
	var curAngle = lftLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListTL.push(newAngle);
		curAngle = newAngle;
	}
	// Ecke rechts oben
	var angListTR = new Array ();
	var curAngle = topLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListTR.push(newAngle);
		curAngle = newAngle;
	}
	// Ecke rechts unten
	var angListBR = new Array ();
	var curAngle = rgtLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBR.push(newAngle);
		curAngle = newAngle;
	}
	// Ecke links unten
	var angListBL = new Array ();
	var curAngle = botLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBL.push(newAngle);
		curAngle = newAngle;
	}
	
	// die Winkel der geraden Elemente
	// Linie oben
	var angListT = new Array ();
	for (var i=0; i<nHorItems; i++) {
		angListT.push(topLineRot);
	}
	// Linie rechts
	var angListR = new Array ();
	for (var i=0; i<nVerItems; i++) {
		angListR.push(rgtLineRot);
	}
	// Linie unten
	var angListB = new Array ();
	for (var i=0; i<nHorItems; i++) {
		angListB.push(botLineRot);
	}
	// Linie links
	var angListL = new Array ();
	for (var i=0; i<nVerItems; i++) {
		angListL.push(lftLineRot);
	}
	
	// die Positionsparameter aller Eckenelemente
	// Ecke links oben
	var posListTL = new Array ();
	for (var i=nItems-1; i>-1; i--) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (oRad-(mRad*xPos))-(objW/2);
		var yPos = Math.sin(curVal);
		y = (oRad-(mRad*yPos))-(objW/2);
		posListTL.push([x,y]);
	}
	// Ecke rechts oben
	var posListTR = new Array ();
	for (var i=0; i<nItems; i++) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (frmW-(oRad-(mRad*xPos)))-(objW/2);
		var yPos = Math.sin(curVal);
		y = (oRad-(mRad*yPos))-(objW/2);
		posListTR.push([x,y]);
	}
	// Ecke rechts unten
	var posListBR = new Array ();
	for (var i=nItems-1; i>-1; i--) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (frmW-(oRad-(mRad*xPos)))-(objW/2);
		var yPos = Math.sin(curVal);
		y = (frmH-(oRad-(mRad*yPos)))-(objW/2);
		posListBR.push([x,y]);
	}
	// Ecke links unten
	var posListBL = new Array ();
	for (var i=0; i<nItems; i++) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (oRad-(mRad*xPos))-(objW/2);
		var yPos = Math.sin(curVal);
		y = (frmH-(oRad-(mRad*yPos)))-(objW/2);
		posListBL.push([x,y]);
	}
	
	// die Positionsparameter aller geraden Elemente
	// Linie oben
	var posListT = new Array ();
	var curVal = oRad-(objW/2);
	posListT.push([curVal, 0]);
	// Linie rechts
	var posListR = new Array ();
	var curVal = oRad-(objW/2);
	posListR.push([frmW-objW, curVal]);
	// Linie unten
	var posListB = new Array ();
	var curVal = (frmW-oRad)-(objW/2);
	posListB.push([curVal, frmH-objW]);
	// Linie links
	var posListL = new Array ();
	var curVal = (frmH-oRad)-(objW/2);
	posListL.push([0, curVal]);
	
	// die Liste aller Positionsparameter
	var allPosList = posListTL.concat(posListT, posListTR, posListR, posListBR, posListB, posListBL, posListL);
	
	// die Liste aller Winkel
	var allAngList = angListTL.concat(angListT, angListTR, angListR, angListBR, angListB, angListBL, angListL);
	
	// wenn die gewnschten Winkel alle gleich sind, die Winkelliste anpassen
	if ((topLineRot == rgtLineRot) && (topLineRot == botLineRot) && (topLineRot == lftLineRot)) {
		var nVals = allAngList.length;
		for (var i=0; i<nVals; i++) {
			allAngList[i] = topLineRot;
		}
	}
	
	// das Grundobjekt in die Gruppieren-Liste aufnehmen
	groupObjects.push(curFrame);
	// das Objekt duplizieren, entsprechend der gewnschten Anzahl
	if (versNum == 7) {
		curFrame.name = "0_";
		for (var i=0; i<nAllItems-1; i++) {
			curFrame = curFrame.duplicate(undefined, [0, 0]);
			curFrame.name = "" + (i+1) + "_";
			groupObjects.push(curFrame);
		}
	}
	else {
		curFrame.label = "0_";
		for (var i=0; i<nAllItems-1; i++) {
			curFrame = curFrame.duplicate(undefined, [0, 0]);
			curFrame.label = "" + (i+1) + "_";
			groupObjects.push(curFrame);
		}
	}
	
	// die Objekte der Reihe nach auf ihre Position verschieben
	// und den Drehwinkelwert zuweisen
	for (var i=0; i<nAllItems; i++) {
		curDoc.pageItems.itemByName("" + i + "_").move(allPosList[i], undefined);
		curDoc.pageItems.itemByName("" + i + "_").rotationAngle = (allAngList[i]);
		curDoc.pageItems.itemByName("" + i + "_").move(undefined, [x1, y1]);
		if (versNum == 7) {
			curDoc.pageItems.itemByName("" + i + "_").name = "";
		}
		else {
			curDoc.pageItems.itemByName("" + i + "_").label = "";
		}
	}
}
////////////////////////////// Funktion "perfectCircle"  Ende  ////////////////////////////////////////

////////////////////////////// Funktion "roundedOne"  Anfang  /////////////////////////////////////////
// Funktion zum Duplizieren des Objekts mit einem gedrehten, eingerckten Ecken-Element
function roundedOne() {
	// ---------- die Werte vorbereiten ----------
	topLineRot =    0;
	rgtLineRot =  -90;
	botLineRot = -180;
	lftLineRot = -270;
	
	// das Grundobjekt in die Gruppieren-Liste aufnehmen
	groupObjects.push(curFrame);
	
	offVal  = (objW*1)+dVal;  // zustzlicher seitlicher Raum fr die Ecken-Elemente (in Zwischenraum-Einheiten)
	moveVal = (objW/3.5);     // Faktor, mit welchem der Vorgabe-Verschiebungswert (= Grsse geteilt durch 3.5) multipliziert wird
	
	// den gewnschten Drehwinkel fr Linie oben zuweisen
	curFrame.rotationAngle = topLineRot;
	// der Raum fr die horizontalen Elemente
	var xRoom = frmW-(offVal*2);
	// die Anzahl horizontaler Elemente ...
	if (dVal > 0) {
		var nItemsHor = (Math.floor(xRoom/(objW+dVal)))+1;
	}
	else {
		var nItemsHor = Math.floor(xRoom/objW);
	}
	// ... und den Versatz ausrechnen
	var rstSpce = xRoom-(nItemsHor*objW);
	var xOffset = (rstSpce/(nItemsHor-1))+objW;
	// der Raum fr die vertikalen Elemente
	var yRoom = frmH-(offVal*2);
	// die Anzahl vertikaler Elemente ...
	if (dVal > 0) {
		var nItemsVer = (Math.floor(yRoom/(objW+dVal)))+1;
	}
	else {
		var nItemsVer = Math.floor(yRoom/objW);
	}
	// ... und den Versatz ausrechnen
	var rstSpce = yRoom-(nItemsVer*objW);
	var yOffset = (rstSpce/(nItemsVer-1))+objW;
	
	// ---------- die vier Rnder ----------
	// oberer Rand (von links nach rechts)
	if (versNum == 7) {
		curFrame.name = "one";
	}
	else {
		curFrame.label = "one";
	}
	curFrame = curFrame.duplicate();
	curFrame.move(undefined, [offVal, 0]);
	if (versNum == 7) {
		curFrame.name = "";
	}
	else {
		curFrame.label = "";
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [xOffset, 0]);
		groupObjects.push(curFrame);
	}
	curFrame = curFrame.duplicate(undefined, [0, 0]);
	curFrame.move([x1+(frmW-objW), y1], undefined);
	if (versNum == 7) {
		curFrame.name = "two";
	}
	else {
		curFrame.label = "two";
	}
	groupObjects.push(curFrame);
	// rechter Rand (von oben nach unten)
	curFrame = curFrame.duplicate();
	curFrame.move(undefined, [0, offVal]);
	if (versNum == 7) {
		curFrame.name = "";
	}
	else {
		curFrame.label = "";
	}
	curFrame.rotationAngle = rgtLineRot;
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, yOffset]);
		groupObjects.push(curFrame);
	}
	// unterer Rand (von rechts nach links)
	curFrame = curFrame.duplicate(undefined, [0, 0]);
	curFrame.move([x1+frmW, y1+(frmH-objW)], undefined);
	curFrame.rotationAngle = botLineRot;
	if (versNum == 7) {
		curFrame.name = "thr";
	}
	else {
		curFrame.label = "thr";
	}
	groupObjects.push(curFrame);
	curFrame = curFrame.duplicate();
	curFrame.move(undefined, [-offVal, 0]);
	if (versNum == 7) {
		curFrame.name = "";
	}
	else {
		curFrame.label = "";
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [-xOffset, 0]);
		groupObjects.push(curFrame);
	}
	curFrame = curFrame.duplicate(undefined, [0, 0]);
	curFrame.move([x1+objW, y1+frmH], undefined);
	if (versNum == 7) {
		curFrame.name = "for";
	}
	else {
		curFrame.label = "for";
	}
	groupObjects.push(curFrame);
	// linker Rand (von unten nach oben)
	curFrame = curFrame.duplicate();
	curFrame.move(undefined, [0, -offVal]);
	if (versNum == 7) {
		curFrame.name = "";
	}
	else {
		curFrame.label = "";
	}
	curFrame.rotationAngle = lftLineRot;
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, -yOffset]);
		groupObjects.push(curFrame);
	}
}
////////////////////////////// Funktion "roundedOne"  Ende  ///////////////////////////////////////////

////////////////////////////// Funktion "rotateObj"  Anfang  //////////////////////////////////////////
// Funktion zum Drehen der Ecken-Objekte
function rotateObj() {
	// wenn die gewnschten Winkel alle gleich sind, jeder Ecke denselben zuweisen
	if ((topLineRot == rgtLineRot) && (topLineRot == botLineRot) && (topLineRot == lftLineRot)) {
		curDoc.pageItems.itemByName("one").rotationAngle = topLineRot;
		curDoc.pageItems.itemByName("two").rotationAngle = topLineRot;
		curDoc.pageItems.itemByName("thr").rotationAngle = topLineRot;
		curDoc.pageItems.itemByName("for").rotationAngle = topLineRot;
	}
	else { 
		curDoc.pageItems.itemByName("one").rotationAngle = lftLineRot-45;
		curDoc.pageItems.itemByName("two").rotationAngle = topLineRot-45;
		curDoc.pageItems.itemByName("thr").rotationAngle = rgtLineRot-45;
		curDoc.pageItems.itemByName("for").rotationAngle = botLineRot-45;
	}
}
////////////////////////////// Funktion "rotateObj"  Ende  ////////////////////////////////////////////

////////////////////////////// Funktion "moveObj"  Anfang  ////////////////////////////////////////////
// Funktion zum Verschieben der Ecken-Objekte
function moveObj() {
	curDoc.pageItems.itemByName("one").move(undefined, [moveVal, moveVal]);
	curDoc.pageItems.itemByName("two").move(undefined, [-moveVal, moveVal]);
	curDoc.pageItems.itemByName("thr").move(undefined, [-moveVal, -moveVal]);
	curDoc.pageItems.itemByName("for").move(undefined, [moveVal, -moveVal]);
	if (versNum == 7) {
		curDoc.pageItems.itemByName("one").name = "";
		curDoc.pageItems.itemByName("two").name = "";
		curDoc.pageItems.itemByName("thr").name = "";
		curDoc.pageItems.itemByName("for").name = "";
	}
	else {
		curDoc.pageItems.itemByName("one").label = "";
		curDoc.pageItems.itemByName("two").label = "";
		curDoc.pageItems.itemByName("thr").label = "";
		curDoc.pageItems.itemByName("for").label = "";
	}
}
////////////////////////////// Funktion "moveObj"  Ende  //////////////////////////////////////////////

////////////////////////////// Funktion "groupObj"  Anfang  ///////////////////////////////////////////
// Funktion zum Gruppieren der Umrandungs-Objekte
function groupObj(groupObjects) {
	var newGroup = app.activeWindow.activeSpread.groups.add(groupObjects);
	return newGroup;
}
////////////////////////////// Funktion "groupObj"  Ende  /////////////////////////////////////////////

////////////////////////////// Funktion "restorePrefs"  Anfang  ///////////////////////////////////////
// die Funktion zum Zurcksetzen der Vorgaben
function restorePrefs() {
	// den Nullpunkt zurcksetzen (falls notwendig) 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = zP; 
	}
	
	// den Bezugspunkt zurcksetzen (falls notwendig)
	if (trp != 1095656308) {
		app.layoutWindows[0].transformReferencePoint = trp;
	}
	
	// Masseinheiten zurcksetzen (falls notwendig)
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
}
////////////////////////////// Funktion "restorePrefs"  Ende  /////////////////////////////////////////